# Models

This directory contains various models for federated learning research in
TensorFlow Federated. The models are all designed for various tasks that can be
performed using datasets in TFF (see the list of datasets
[here](https://www.tensorflow.org/federated/api_docs/python/tff/simulation/datasets)).

These models are intended primarily for research in TFF (see
[Using TFF for Federated Learning Research](https://github.com/tensorflow/federated/blob/main/docs/tff_for_research.md))
and are not necessarily intended to be production-ready. Moreover, these models
are tied to prior and ongoing research. While changes designed to clean up or
speed up model training are welcome, any fundamental changes to the models
should be instead implemented as new models.
